#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "vesavbe.h"

/*----------------------------------------------------------*/
void print_infos (void)
{
  VBE_VbeInfoBlock     vbei;
  VBE_ModeInfoBlock    ModeInfo;

  VBE_Controller_Information  (&vbei);
  printf ("VBE Version: %i.%i\n", vbei.vbeVersion.hi, vbei.vbeVersion.lo);
  printf ("VBE Oem    : %s\n", vbei.OemStringPtr);

  printf ("ModeList: \n");
  for ( int i=0; vbei.VideoModePtr[i]!=0xffff; i++ )
  {
    short Mode = vbei.VideoModePtr[i];
    VBE_Mode_Information (Mode, &ModeInfo);
    printf ("Mode = 0x%x\tx=%4i\ty=%4i\tbits=%i\tMM=%i\n", Mode, ModeInfo.XResolution, ModeInfo.YResolution, ModeInfo.BitsPerPixel,ModeInfo.MemoryModel);
  }
}

/*----------------------------------------------------------*/
void test_640x480x16 (void)
{
  short Mode = VBE_FindMode(640,480,16);
  if ( Mode==-1 ) {
    printf ("Mode not found\n");
    return;
  }
  if ( !VBE_IsModeLinear(Mode)) {
    printf ("Mode has no Linear Frame Buffer\n");
    return;
  }
  VBE_SetMode(Mode, 1, 1);

  short *VIDEO = (short *) VBE_GetVideoPtr (Mode);

  for ( int y=0; y<480; y++ )
  for ( int x=0; x<640; x++ ) {
    VIDEO[640*y+x] = x+(12<<8);
  }
  getch();
  VBE_SetMode (3,0,1);
}

/*----------------------------------------------------------*/
void main (void)
{
  VBE_Init();

  print_infos();
  test_640x480x16 ();


  VBE_Done();
}


