#include "vesavbe.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>

/*-------------------------------------------------*/
void error (char *msg)
{
  printf ("Error: s\n", msg);
  exit(1);
}

/*-------------------------------------------------*/
void Test_8Bit (void)
{
  // Test 8-bit modes:
  int mode;
  VBE_ModeInfoBlock ModeInfo;
  int x;
  int y;
  char *VIDEO;

  mode = VBE_FindMode (640,480,8);
  if ( mode==-1 ) error( "640x480x8 not found");
  if ( !VBE_IsModeLinear(mode)) error ("Mode is not linear");

  // Set the video-mode
  VBE_SetMode (mode, 1, 1);
  // Get a pointer to the linear screen-memory
  VIDEO = VBE_GetVideoPtr (mode);

  // this should never occur if you test the linearity!
  if ( !VIDEO ) error ("LFB invalid");

  // We also need the ModeInformationBlock!

  VBE_Mode_Information (mode, &ModeInfo);


  for ( y=0; y<ModeInfo.YResolution; y++ )
  for ( x=0; x<ModeInfo.XResolution; x++ )
   VIDEO[ModeInfo.BytesPerScanline*y+x]=x*y;
 }

/*-------------------------------------------------*/
void main (void)
{
  // VESA VBE 2.0 Interface test
  VBE_Init();

  Test_8Bit ();
  getch();
  VBE_SetMode (3, 0, 1);
  VBE_Done();
}
