/*--------------------------------------------------------------------
   Ejemplo5. visualizacin de archivo PCX de 256 colores en SuperVGA.
   El PCX puede ser de cualquier resolucin entre 320x200 y 1024x768.
 --------------------------------------------------------------------*/
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include "vesavbe.h"

void SVGAPutPixel( unsigned long, unsigned long, char );
char ShowPCX( char *, short, short );

char *VIDEO;

/*------------------------------------------------------*/
void main( int argc, char *argv[] )
{
 short Mode;

  if( argc < 2 )
  {
     printf("\n Uso:   ejemplo5 fichero.pcx   (de 256 colores). \n");
     return;
  }

 /* inicializacin del modo SVGA */

  VBE_Init();
  Mode = VBE_FindMode(640,480,8);
  if ( Mode==-1 )
  {
    printf ("Mode not found\n");
    return;
  }

  if ( !VBE_IsModeLinear(Mode))
  {
    printf ("Mode has no Linear Frame Buffer\n");
    return;
  }

  VBE_SetMode (Mode, 1, 1);
  VIDEO = VBE_GetVideoPtr (Mode);

  /* visualizamos el archivo PCX */
  ShowPCX( argv[1], 640/2, 480/2 );
  getch();

  VBE_SetMode (3,0,1);
  VBE_Done();

}

/*-----------------------------------------------------------*/
void SVGAPutPixel( unsigned long x, unsigned long y, char color )
{
  if( x<640 && y<480 )
   VIDEO[ (y*640)+x ] = color;  
}

/*-----------------------------------------------------------*/
unsigned char palette[768];

char ShowPCX( char *filename, short centerx, short centery )
{
  char oldfore, oldback;
  FILE *fptr;
  char header[128];
  unsigned char c, runlen;
  short i, r;
  short w, h;
  short tx, ty;
  short maxx, maxy;
  short drawing;

  fptr = fopen(filename,"rb");
	if (fptr==NULL) return 1;

  r = fread( &header, 1, 128, fptr );
  if ( r != 128 )
  {
    fclose(fptr);
    return 2 ;
  }

  if ( header[1] != 5 || header[3] != 8 ) return 3 ;

  memcpy( &w, &header[8], 2 );
  memcpy( &h, &header[10], 2 );

  centerx = (centerx-(w/2));
  centery = (centery-(h/2));

  fseek(fptr,-769L,SEEK_END);

  c = fgetc(fptr);
	if (c!=0x0C)
  {
    fclose(fptr);
     return 5 ;
  }

  r = fread( &palette, 1, 768, fptr );
    if (r != 768)
  {
    fclose(fptr);
     return 6 ;
  }

  for(i=0 ; i<768 ; i++)
   palette[i] = palette[i]>>2 ;

  outp( 0x3c8, 0 );
  for(i=0 ; i<768 ; i++)
   outp( 0x3c9, palette[i] );
  

  fseek(fptr,128L,SEEK_SET);

  tx = centerx;
  ty = centery;
  maxx = centerx+w;
  maxy = centery+h;

  drawing = 1;

	while (drawing) {

    c=fgetc(fptr);

    if ((c & 0xc0) == 0xc0) {
			runlen = c & 0x3f;
			c=fgetc(fptr);
			}
		else

      runlen = 1;

    do {

      SVGAPutPixel( tx , ty , c );

     if ( ++tx > maxx )
	 {
      tx = centerx;
      ty++ ;

	 }

      if ( ty > maxy ) drawing = 0;

      } while ( drawing && --runlen > 0 );

    }

  fclose(fptr);
  return(0);

}
